#pragma once

// cons
template<int Head, typename Tail>
struct cons {
	enum { head = Head };
	typedef Tail tail;
};

// nil
struct nil {};

// concat
template<typename One, typename Two>
struct concat;

template<int OneHead, typename OneTail, typename Two>
struct concat<
	cons<OneHead, OneTail>,
	Two
	> {
	typedef cons<
		OneHead,
		typename concat<OneTail, Two>::value
	> value;
};

template<typename Two>
struct concat<nil, Two> {
	typedef Two value;
};

